import { NodeOrString, GenericObject } from "./interfaces";

interface DomForm {
    /**
     * Serialize a form field to a JavaScript object.
     */
    fieldToObject(inputNode: NodeOrString): GenericObject;

    /**
     * Serialize a form node to a JavaScript object.
     */
    toObject(fromNode: HTMLFormElement | string): GenericObject;

    /**
     * Returns a URL-encoded string representing the form passed as either a
     * node or string ID identifying the form to serialize
     */
    toQuery(fromNode: HTMLFormElement | string): string;

    /**
     * Create a serialized JSON string from a form node or string
     * ID identifying the form to serialize
     */
    toJson(formNode: HTMLFormElement | string, prettyPrint?: boolean): string;
}

declare const domForm: DomForm;
export = domForm;